// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	"LAPP_ACURA_MOM_BACKEND/grmi"
	meta "LAPP_ACURA_MOM_BACKEND/meta/report"
	model "LAPP_ACURA_MOM_BACKEND/models/report"
	"github.com/go-xorm/xorm"
	"xorm.io/core"
)

/******************************************************************************
 *
 * @Struct Name              : ArcDisplayInfoDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : ArcDisplayInfo的数据访问对象实现
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-06-21 11:39:48
 *
 ******************************************************************************/
type ArcDisplayInfoDAOImplement struct {
	session *xorm.Session
	meta    *grmi.Entity
}

/******************************************************************************
 *
 * @Function Name            : NewArcDisplayInfoDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个ArcDisplayInfoDAOImplement实例
 *
 * @Function Parameters      : xorm会话
 *

 * @Return Value             : ArcDisplayInfoDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-06-21 11:39:48
 *
 ******************************************************************************/
func NewArcDisplayInfoDAOImplement(session *xorm.Session) *ArcDisplayInfoDAOImplement {
	return &ArcDisplayInfoDAOImplement{session, &meta.ArcDisplayInfo}
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/report/ArcDisplayInfoDAO.InsertOne
 *
 ******************************************************************************/
func (impl *ArcDisplayInfoDAOImplement) InsertOne(entity *model.ArcDisplayInfo) error {

	_, err := impl.session.Table(impl.meta.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/report/ArcDisplayInfoDAO.DeleteOne
 *
 ******************************************************************************/
func (impl *ArcDisplayInfoDAOImplement) DeleteOne(pos int, descCN string) error {
	_, err := impl.session.Table(impl.meta.TableName).ID(core.PK{pos, descCN}).Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/report/ArcDisplayInfoDAO.SelectOne
 *
 ******************************************************************************/
func (impl *ArcDisplayInfoDAOImplement) SelectOne(pos int, descCN string) (*model.ArcDisplayInfo, error) {
	var data model.ArcDisplayInfo
	ok, err := impl.session.Table(impl.meta.TableName).ID(core.PK{pos, descCN}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/report/ArcDisplayInfoDAO.UpdateOne
 *
 ******************************************************************************/
func (impl *ArcDisplayInfoDAOImplement) UpdateOne(entity *model.ArcDisplayInfo) error {

	_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/report/ArcDisplayInfoDAO.Insert
 *
 ******************************************************************************/
func (impl *ArcDisplayInfoDAOImplement) Insert(entities *[]model.ArcDisplayInfo) error {
	_, err := impl.session.Table(impl.meta.TableName).Insert(entities)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/report/ArcDisplayInfoDAO.Delete
 *
 ******************************************************************************/
func (impl *ArcDisplayInfoDAOImplement) Delete(entities *[]model.ArcDisplayInfo) error {
	for _, entity := range *entities {

		_, err := impl.session.Table(impl.meta.TableName).ID(entity.GetKey()).Delete(impl.meta.Indicator)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/report/ArcDisplayInfoDAO.DeleteWhere
 *
 ******************************************************************************/
func (impl *ArcDisplayInfoDAOImplement) DeleteWhere(predicates []grmi.Predicate) error {

	parameters := []interface{}{}
	where := "1=1 "

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/report/ArcDisplayInfoDAO.Select
 *
 ******************************************************************************/
func (impl *ArcDisplayInfoDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.ArcDisplayInfo, error) {

	parameters := []interface{}{}
	where := "1=1 "

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.ArcDisplayInfo, 0, 10)
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/report/ArcDisplayInfoDAO.SelectAndPaging
 *
 ******************************************************************************/
func (impl *ArcDisplayInfoDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {

	parameters := []interface{}{}
	where := "1 = 1 "

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	count, err := session.Count(impl.meta.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}

	orderBy := " order by "
	if orderByFields != nil {
		for _, field := range orderByFields {
			orderBy += ", " + field.ColumnName
		}
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.ArcDisplayInfo, 0, 10)
	where = " where " + where
	err = impl.session.Table(impl.meta.TableName).SQL("select * from "+impl.meta.TableName+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/report/ArcDisplayInfoDAO.Update
 *
 ******************************************************************************/
func (impl *ArcDisplayInfoDAOImplement) Update(entities *[]model.ArcDisplayInfo) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]

		_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/report/ArcDisplayInfoDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *ArcDisplayInfoDAOImplement) UpdateWhere(predicates []grmi.Predicate, entity *model.ArcDisplayInfo, columns ...string) error {

	parameters := []interface{}{}
	where := "1=1 "

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Cols(columns...).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}
